searchNodes=[{"doc":"A library of two- and three-dimensional vector operations. All vectors are represented as tuples with either two or three elements. Examples iex&gt; # Vector Tripple Product Identity ...&gt; a = { 2 , 3 , 1 } ...&gt; b = { 1 , 4 , - 2 } ...&gt; c = { - 1 , 2 , 1 } ...&gt; Vector . equal? ( ...&gt; Vector . cross ( Vector . cross ( a , b ) , c ) , ...&gt; Vector . subtract ( Vector . multiply ( b , Vector . dot ( a , c ) ) , Vector . multiply ( a , Vector . dot ( b , c ) ) ) ) true","ref":"Vector.html","title":"Vector","type":"module"},{"doc":"Adds two vectors Examples iex&gt; Vector . add ( { 3 , - 4 } , { 2 , 1 } ) { 5 , - 3 } iex&gt; Vector . add ( { - 2 , 0 , 5 } , { 0 , 0 , 0 } ) { - 2 , 0 , 5 } iex&gt; Vector . add ( { 2 , 1 , - 2 } , Vector . reverse ( { 2 , 1 , - 2 } ) ) { 0 , 0 , 0 }","ref":"Vector.html#add/2","title":"Vector.add/2","type":"function"},{"doc":"Returns the basis vector for the given axis Examples iex&gt; Vector . basis ( :x ) { 1 , 0 , 0 } iex&gt; Vector . basis ( :y ) { 0 , 1 , 0 } iex&gt; Vector . component ( Vector . basis ( :y ) , :y ) 1","ref":"Vector.html#basis/1","title":"Vector.basis/1","type":"function"},{"doc":"Returns the scalar component for the axis given Examples iex&gt; Vector . component ( { 3 , - 4 } , :y ) - 4 iex&gt; Vector . component ( { - 6 , 0 , 8 } , :z ) 8 iex&gt; Vector . component ( { 1 , - 2 } , :z ) 0 iex&gt; Vector . component ( Vector . basis ( :x ) , :z ) 0","ref":"Vector.html#component/2","title":"Vector.component/2","type":"function"},{"doc":"Returns the cross product of two vectors A ⨯ B Examples iex&gt; Vector . cross ( { 2 , 3 } , { 1 , 4 } ) { 0 , 0 , 5 } iex&gt; Vector . cross ( { 2 , 2 , - 1 } , { 1 , 4 , 2 } ) { 8 , - 5 , 6 } iex&gt; Vector . cross ( { 3 , - 3 , 1 } , { 4 , 9 , 2 } ) { - 15 , - 2 , 39 }","ref":"Vector.html#cross/2","title":"Vector.cross/2","type":"function"},{"doc":"Returns the norm (magnitude) of the cross product of two vectors A ⨯ B Examples iex&gt; Vector . cross_norm ( { 2 , 3 } , { 1 , 4 } ) 5 iex&gt; Vector . cross_norm ( { 1 , 4 } , { 2 , 2 } ) 6 iex&gt; Vector . cross_norm ( { 2 , 0 , - 1 } , { 0 , 3 , 3 } ) 9.0 iex&gt; Float . floor ( :math . pow ( Vector . cross_norm ( { 2 , 2 , - 1 } , { 1 , 4 , 2 } ) , 2 ) ) 125.0","ref":"Vector.html#cross_norm/2","title":"Vector.cross_norm/2","type":"function"},{"doc":"Divide a vector by scalar value s Examples iex&gt; Vector . divide ( { 3 , - 4 } , 2.5 ) { 1.2 , - 1.6 } iex&gt; Vector . divide ( { - 2 , 0 , 5 } , - 2 ) { 1.0 , 0.0 , - 2.5 }","ref":"Vector.html#divide/2","title":"Vector.divide/2","type":"function"},{"doc":"Returns the dot product of two vectors A ⨯ B Examples iex&gt; Vector . dot ( { 2 , 3 } , { 1 , 4 } ) 14 iex&gt; Vector . dot ( { 1 , 4 } , { 2 , 2 } ) 10 iex&gt; Vector . dot ( { 2 , 0 , - 1 } , { 0 , 3 , 3 } ) - 3","ref":"Vector.html#dot/2","title":"Vector.dot/2","type":"function"},{"doc":"Compares two vectors for equality, with an optional tolerance Examples iex&gt; Vector . equal? ( { 3 , - 4 } , { 3 , - 4 } ) true iex&gt; Vector . equal? ( { 3 , - 4 } , { 3.0001 , - 3.9999 } ) false iex&gt; Vector . equal? ( { 3 , - 4 } , { 3.0001 , - 3.9999 } , 0.001 ) true iex&gt; Vector . equal? ( { 3 , - 4 , 1 } , { 3.0001 , - 3.9999 , 1.0 } , 0.001 ) true","ref":"Vector.html#equal?/3","title":"Vector.equal?/3","type":"function"},{"doc":"Multiply a vector by scalar value s Examples iex&gt; Vector . multiply ( { 3 , - 4 } , 2.5 ) { 7.5 , - 10.0 } iex&gt; Vector . multiply ( { - 2 , 0 , 5 } , - 2 ) { 4 , 0 , - 10 }","ref":"Vector.html#multiply/2","title":"Vector.multiply/2","type":"function"},{"doc":"Returns the norm (magnitude) of a vector Examples iex&gt; Vector . norm ( { 3 , 4 } ) 5.0 iex&gt; Vector . norm ( { - 1 , 0 } ) 1 iex&gt; Vector . norm ( { 0 , - 2 , 0 } ) 2","ref":"Vector.html#norm/1","title":"Vector.norm/1","type":"function"},{"doc":"Returns the square of the norm norm (magnitude) of a vector Examples iex&gt; Vector . norm_squared ( { 3 , 4 } ) 25 iex&gt; Vector . norm_squared ( { 1 , 0 } ) 1 iex&gt; Vector . norm_squared ( { 2 , 0 , - 1 } ) 5 iex&gt; Vector . norm_squared ( { - 2 , 3 , 1 } ) 14","ref":"Vector.html#norm_squared/1","title":"Vector.norm_squared/1","type":"function"},{"doc":"Returns a new coordinate by projecting a given length distance from coordinate start along vector Examples iex&gt; Vector . project ( { 3 , - 4 } , { - 1 , 1 } , 4 ) { 1.4 , - 2.2 } iex&gt; Vector . project ( { - 6 , 0 , 8 } , { 1 , - 2 , 0.4 } , 2.5 ) { - 0.5 , - 2.0 , 2.4 } iex&gt; Vector . project ( { - 2 , 1 , 3 } , { 0 , 0 , 0 } , 2.5 ) |&gt; Vector . norm ( ) 2.5","ref":"Vector.html#project/3","title":"Vector.project/3","type":"function"},{"doc":"Reverses a vector Examples iex&gt; Vector . reverse ( { 3 , - 4 } ) { - 3 , 4 } iex&gt; Vector . reverse ( { - 2 , 0 , 5 } ) { 2 , 0 , - 5 } iex&gt; Vector . cross_norm ( { - 2 , 3 , 5 } , Vector . reverse ( { - 2 , 3 , 5 } ) ) 0","ref":"Vector.html#reverse/1","title":"Vector.reverse/1","type":"function"},{"doc":"Subtract vector B from vector A . Equivalent to Vector.add(A, Vector.revers(B)) Examples iex&gt; Vector . subtract ( { 3 , - 4 } , { 2 , 1 } ) { 1 , - 5 } iex&gt; Vector . subtract ( { - 2 , 0 , 5 } , { - 3 , 1 , 2 } ) { 1 , - 1 , 3 }","ref":"Vector.html#subtract/2","title":"Vector.subtract/2","type":"function"},{"doc":"Returns the unit vector parallel ot the given vector. This will raise an ArithmeticError if a zero-magnitude vector is given. Use unit_safe if there is a chance that a zero-magnitude vector will be sent. Examples iex&gt; Vector . unit ( { 3 , 4 } ) { 0.6 , 0.8 } iex&gt; Vector . unit ( { 8 , 0 , 6 } ) { 0.8 , 0.0 , 0.6 } iex&gt; Vector . unit ( { - 2 , 0 , 0 } ) { - 1.0 , 0.0 , 0.0 } iex&gt; Vector . unit ( { 0 , 0 , 0 } ) ** (ArithmeticError) bad argument in arithmetic expression","ref":"Vector.html#unit/1","title":"Vector.unit/1","type":"function"},{"doc":"Returns the unit vector parallel ot the given vector, but will handle the vectors {0, 0} and {0, 0, 0} by returning the same vector Examples iex&gt; Vector . unit_safe ( { 3 , 4 } ) { 0.6 , 0.8 } iex&gt; Vector . unit_safe ( { 0 , 0 } ) { 0 , 0 } iex&gt; Vector . unit_safe ( { 0 , 0 , 0 } ) { 0 , 0 , 0 }","ref":"Vector.html#unit_safe/1","title":"Vector.unit_safe/1","type":"function"},{"doc":"","ref":"Vector.html#t:location/0","title":"Vector.location/0","type":"type"},{"doc":"","ref":"Vector.html#t:vector/0","title":"Vector.vector/0","type":"type"}]